# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ADHybridHealthService::Mgmt::V2014_01_01
  module Models
    #
    # The connector object error.
    #
    class ConnectorObjectError

      include MsRestAzure

      # @return [String] The error Id.
      attr_accessor :id

      # @return [String] The run step result Id.
      attr_accessor :run_step_result_id

      # @return [String] The connector Id.
      attr_accessor :connector_id

      # @return [String] The type of error.
      attr_accessor :type

      # @return [String] The error code.
      attr_accessor :error_code

      # @return [String] The message for the object error.
      attr_accessor :message

      # @return [Integer] The entry number for object error occurred.
      attr_accessor :entry_number

      # @return [Integer] The line number for the object error.
      attr_accessor :line_number

      # @return [Integer] The column number for the object error.
      attr_accessor :column_number

      # @return [String] The distinguished name of the object.
      attr_accessor :dn

      # @return [String] The name for the anchor of the object.
      attr_accessor :anchor

      # @return [String] The attribute name of the object.
      attr_accessor :attribute_name

      # @return [String] The server side error details.
      attr_accessor :server_error_detail

      # @return [Array<String>] The value corresponding to attribute name.
      attr_accessor :values


      #
      # Mapper for ConnectorObjectError class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ConnectorObjectError',
          type: {
            name: 'Composite',
            class_name: 'ConnectorObjectError',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              run_step_result_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'runStepResultId',
                type: {
                  name: 'String'
                }
              },
              connector_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'connectorId',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              error_code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorCode',
                type: {
                  name: 'String'
                }
              },
              message: {
                client_side_validation: true,
                required: false,
                serialized_name: 'message',
                type: {
                  name: 'String'
                }
              },
              entry_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'entryNumber',
                type: {
                  name: 'Number'
                }
              },
              line_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lineNumber',
                type: {
                  name: 'Number'
                }
              },
              column_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'columnNumber',
                type: {
                  name: 'Number'
                }
              },
              dn: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dn',
                type: {
                  name: 'String'
                }
              },
              anchor: {
                client_side_validation: true,
                required: false,
                serialized_name: 'anchor',
                type: {
                  name: 'String'
                }
              },
              attribute_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'attributeName',
                type: {
                  name: 'String'
                }
              },
              server_error_detail: {
                client_side_validation: true,
                required: false,
                serialized_name: 'serverErrorDetail',
                type: {
                  name: 'String'
                }
              },
              values: {
                client_side_validation: true,
                required: false,
                serialized_name: 'values',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
