# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ADHybridHealthService::Mgmt::V2014_01_01
  module Models
    #
    # The replication summary for the domain controller inbound neighbor.
    #
    class InboundReplicationNeighbor

      include MsRestAzure

      # @return [String] The name of the source domain controller.
      attr_accessor :source_domain_controller

      # @return [Integer] The number of consecutive failure counts.
      attr_accessor :consecutive_failure_count

      # @return [String] The naming context.
      attr_accessor :naming_context

      # @return [Integer] The health status for the domain controller
      attr_accessor :status

      # @return [DateTime] The last time a sync was attempted on the domain
      # controller.
      attr_accessor :last_attempted_sync

      # @return [DateTime] The last time when a successful sync happened.
      attr_accessor :last_successful_sync

      # @return [Integer] The last error code.
      attr_accessor :last_error_code

      # @return [String] The error message of the last error.
      attr_accessor :last_error_message

      # @return [String] The error title.
      attr_accessor :error_title

      # @return [String] The error description.
      attr_accessor :error_description

      # @return [String] The link for the fix of the error.
      attr_accessor :fix_link

      # @return [String] The details of the fix.
      attr_accessor :fix_details

      # @return [String] The additional details.
      attr_accessor :additional_info


      #
      # Mapper for InboundReplicationNeighbor class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'InboundReplicationNeighbor',
          type: {
            name: 'Composite',
            class_name: 'InboundReplicationNeighbor',
            model_properties: {
              source_domain_controller: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceDomainController',
                type: {
                  name: 'String'
                }
              },
              consecutive_failure_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'consecutiveFailureCount',
                type: {
                  name: 'Number'
                }
              },
              naming_context: {
                client_side_validation: true,
                required: false,
                serialized_name: 'namingContext',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'Number'
                }
              },
              last_attempted_sync: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastAttemptedSync',
                type: {
                  name: 'DateTime'
                }
              },
              last_successful_sync: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastSuccessfulSync',
                type: {
                  name: 'DateTime'
                }
              },
              last_error_code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastErrorCode',
                type: {
                  name: 'Number'
                }
              },
              last_error_message: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastErrorMessage',
                type: {
                  name: 'String'
                }
              },
              error_title: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorTitle',
                type: {
                  name: 'String'
                }
              },
              error_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorDescription',
                type: {
                  name: 'String'
                }
              },
              fix_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fixLink',
                type: {
                  name: 'String'
                }
              },
              fix_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fixDetails',
                type: {
                  name: 'String'
                }
              },
              additional_info: {
                client_side_validation: true,
                required: false,
                serialized_name: 'additionalInfo',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
